//
//  AgreementController.swift
//  TIME
//
//  Created by JIDAPA LOMTAKU on 27/8/2563 BE.
//  Copyright © 2563 NSTDA. All rights reserved.
//

import UIKit

class AgreementController: UIViewController, UIWebViewDelegate {
    
    @IBOutlet weak var vAgreement: UIView!
    @IBOutlet weak var vbtnAgreement: UIView!
    @IBOutlet weak var vbtnDisAgreement: UIView!
    @IBOutlet weak var lConsentDesc: UILabel!
    @IBOutlet weak var webvConsentDesc: UIWebView!
    fileprivate var loadingProgress : UIActivityIndicatorView!
    
    var isCheckAgreement = ""
    var appDelegate:AppDelegate!
    var isFirstTime = true
    
    override func viewDidLoad() {
        super.viewDidLoad()
        appDelegate = UIApplication.shared.delegate as! AppDelegate
        if #available(iOS 13.0, *) {
            overrideUserInterfaceStyle = .light // force light mode
        }
        
        vAgreement.isHidden = true
        vbtnAgreement.isHidden = true
        vbtnDisAgreement.isHidden = true
        
        // loading animation
        loadingProgress = UIActivityIndicatorView() as UIActivityIndicatorView
        loadingProgress.frame = CGRect(x: 0, y: 0,
            width: UIScreen.main.bounds.size.width,
            height: UIScreen.main.bounds.size.height)
        loadingProgress.isOpaque = false
        loadingProgress.backgroundColor = UIColor( red: 0.95, green: 0.95, blue: 0.95, alpha: 0.5 )
        loadingProgress.hidesWhenStopped = true
        loadingProgress.style = UIActivityIndicatorView.Style.gray
        view.addSubview(loadingProgress)
        
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        
        if isFirstTime {

            DispatchQueue.main.async(execute: { () -> Void in
                self.loadingProgress.startAnimating()
            })
            
            //step : 0 check aaccount agreement
            if self.isCheckAgreement.isEmpty {
                let resultCheckAgreement = self.checkSubmitAgreement()
                //print("resultCheckAgreement: \(resultCheckAgreement)")
                // use to test agreement popup
                //resultCheckAgreement = "disagree"
                
                if resultCheckAgreement == "agree"{
                    DispatchQueue.main.async(execute: { () -> Void in
                        self.loadingProgress.stopAnimating()
                        self.isCheckAgreement = "agree"
                        self.performSegue(withIdentifier: "segue_agreement_to_loading", sender: nil)
                        // set segue to new page here
                        // nonokyo: set here
                    })
                }
                    //step:0.2  goto account consent
                else if resultCheckAgreement == "disagree"{
                    DispatchQueue.main.async(execute: { () -> Void in
                        let descConsentHtml = self.requestConsentDetailData()
                        print("resultDescConsent: \(descConsentHtml)")
                        
                        self.loadingProgress.stopAnimating()
                        self.isCheckAgreement = "disagree"
                        self.vbtnAgreement.isHidden = false
                        self.vbtnDisAgreement.isHidden = false
                        self.vAgreement.isHidden = false
                        self.webvConsentDesc.delegate = self
                        self.webvConsentDesc.loadHTMLString(descConsentHtml, baseURL: nil)
                        // set segue to new page here
                    })
                }
                else if resultCheckAgreement == "ConnectionTimeout" {
                    DispatchQueue.main.async(execute: { () -> Void in
                        Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: "กรุณาเชื่อมต่อ wifi ภายในสำนักงาน", isCloseApplication: true)
                    })
                }
                else if resultCheckAgreement == "InternetOffline"{
                    DispatchQueue.main.async(execute: { () -> Void in
                        Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: DataString.error_connection_timeout)
                    })
                }
                else {
                    DispatchQueue.main.async(execute: { () -> Void in
                        Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: "กรุณาเชื่อมต่อ wifi ภายในสำนักงาน", isCloseApplication: true)
                    })
                }
            }
            
            isFirstTime = false
        }
        // Do any additional setup after loading the view.
        
    }
    
    func webView(_ webView: UIWebView, shouldStartLoadWith request: URLRequest, navigationType: UIWebView.NavigationType) -> Bool {
        switch navigationType {
        case .linkClicked:
            // Open links in Safari
            guard let url = request.url else { return true }
            
            if #available(iOS 10.0, *) {
                UIApplication.shared.open(url, options: [:], completionHandler: nil)
            } else {
                // openURL(_:) is deprecated in iOS 10+.
                UIApplication.shared.openURL(url)
            }
            return false
        default:
            // Handle other navigation types...
            return true
        }
    }
    
    override func viewWillAppear(_ animated: Bool) {
        NotificationCenter.default.addObserver(self, selector: #selector(keyboardWillShow), name: UIResponder.keyboardWillShowNotification, object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(keyboardWillHide), name: UIResponder.keyboardWillHideNotification, object: nil)
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        NotificationCenter.default.removeObserver(self, name: UIResponder.keyboardWillShowNotification, object: self.view.window)
        NotificationCenter.default.removeObserver(self, name: UIResponder.keyboardWillHideNotification, object: self.view.window)
    }
    
    //step 0
    /*
     Note : check account agreement
     */
    func checkSubmitAgreement() -> String {
        
        var returnResult = 0
        var returnMessage = ""
        let semaphore = DispatchSemaphore.init(value: 0)
        
        // data
        // nonokyo: set here
        let data = appDelegate.UUID
        
        // url
        // nonokyo: set here
        let url = DataFactory.SUMBIT_API_CHECK_AGREEMENT_URL
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
        request.httpMethod = "POST"
        request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
        request.timeoutInterval = 15.0
        
        // post data
        // ptoon: set here
        let postData = DataFactory.generatePostData(
            [DataFactory.GeneratePostObject(name: "data_Mac", value: EncryptDecryptAlgorithm.EncryptData(data)),
             DataFactory.GeneratePostObject(name: "data_MacK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
        )
        // display sent data
        if DataFactory.DEBUG {
            print("url=\(request.url!)")
            print("data=\n\(postData)")
        }
        request.httpBody = postData.data(using: String.Encoding.utf8)
        
        //let session = URLSession.shared
        let sessionConfig = URLSessionConfiguration.default
        sessionConfig.timeoutIntervalForRequest = 15.0
        sessionConfig.timeoutIntervalForResource = 15.0
        let session = URLSession(configuration: sessionConfig)
        let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
            /*if error != nil {
             DispatchQueue.main.async(execute: { () -> Void in
             self.loadingProgress.stopAnimating()
             Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: DataString.error_connection_timeout)
             })
             return
             }*/
            
            if error != nil {  //disconnected to server
                if DataFactory.DEBUG {
                    print("ERROR: \(error!)")
                }
                if error!._code == -1001 {
                    returnResult = 0
                    returnMessage = "ConnectionTimeout"
                }
                else {
                    returnResult = 0
                    returnMessage = "InternetOffline"
                }
                do { semaphore.signal() }
                return
            }
            
            let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
            print("result: \(result)")
            
            if !result.isEmpty {
                // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                if result.hasPrefix("<!DOCTYPE") {
                    returnMessage = "Error: return data corrupted, please contact administrator."
                    returnResult = 0
                    do { semaphore.signal() }
                }
                    // ========== RESPONSE SUCCESS ===========
                else if result == "agree" {
                    returnResult = 1
                    returnMessage = result
                    do { semaphore.signal() }
                }
                else if result == "disagree"{
                    returnResult = 2
                    returnMessage = result
                    do { semaphore.signal() }
                }
                    // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                else {
                    returnMessage = "Error: return data corrupted, please contact administrator. message: " + result
                    returnResult = 0
                    do { semaphore.signal() }
                }
            }
            else {
                //returnMessage = "response == null"
                returnResult = 0
                do { semaphore.signal() }
            }
            do { semaphore.signal() }
        })
        
        task.resume()
        semaphore.wait()
        
        if returnResult == 1 {
            return returnMessage
        }
        else {
            return returnMessage
        }
    }
    
    //step: 0.1
    func requestConsentDetailData() -> String{
        
        var returnResult = 0
        var returnMessage = ""
        let semaphore = DispatchSemaphore.init(value: 0)
        
        // data
        // nonokyo: set here
        let data = appDelegate.UUID
        
        // url
        // nonokyo: set here
        let url = DataFactory.REQUEST_API_CONSENT_DETAIL_DATA
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
        request.httpMethod = "GET"
        request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
        
        // display sent data
        if DataFactory.DEBUG {
            print("url=\(request.url!)")
        }
        
        let session = URLSession.shared
        let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
            
            if error != nil {  //disconnected to server
                if DataFactory.DEBUG {
                    print("ERROR: \(error!)")
                }
                returnResult = 0
                returnMessage = "InternetOffline"
                do { semaphore.signal() }
                return
            }
            
            let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
            print("result: \(result)")
            
            if !result.isEmpty {
                // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                if result.hasPrefix("<!DOCTYPE") {
                    returnMessage = "Error: return data corrupted, please contact administrator."
                    returnResult = 0
                    do { semaphore.signal() }
                }
                    // ========== RESPONSE SUCCESS ===========
                else if result .hasPrefix("<div"){
                    returnResult = 1
                    returnMessage = result
                    do { semaphore.signal() }
                }
                    // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                else {
                    returnMessage = "Error: return data corrupted, please contact administrator. message: " + result
                    returnResult = 0
                    do { semaphore.signal() }
                }
            }
            else {
                //returnMessage = "response == null"
                returnResult = 0
                do { semaphore.signal() }
            }
            do { semaphore.signal() }
        })
        
        task.resume()
        semaphore.wait()
        
        if returnResult == 1 {
            return returnMessage
        }
        else {
            return returnMessage
        }
    }
    
    //step: 0.2
    func submitAccountConsent (){
        // data
        // nonokyo: set here
        let data = appDelegate.UUID
        
        // url
        // nonokyo: set here
        let url = DataFactory.SUMBIT_API_ACCOUNT_CONSENT_URL
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
        request.httpMethod = "POST"
        request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
        
        // post data
        // ptoon: set here
        let postData = DataFactory.generatePostData(
            [DataFactory.GeneratePostObject(name: "data_Mac", value: EncryptDecryptAlgorithm.EncryptData(data)),
             DataFactory.GeneratePostObject(name: "data_MacK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
        )
        // display sent data
        if DataFactory.DEBUG {
            print("url=\(request.url!)")
            print("data=\n\(postData)")
        }
        request.httpBody = postData.data(using: String.Encoding.utf8)
        
        DispatchQueue.main.async(execute: { () -> Void in
            self.loadingProgress.startAnimating()
        })
        
        let session = URLSession.shared
        let task = session.dataTask(with: request as URLRequest) { (data, response, error) -> Void in
            
            if error != nil {
                DispatchQueue.main.async(execute: { () -> Void in
                    self.loadingProgress.stopAnimating()
                    Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: DataString.error_connection_timeout)
                })
                return
            }
            
            var returnResult = 0
            var returnMessage = ""
            let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
            print("resultAccountConsent: \(result)")
            
            if !result.isEmpty {
                // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                if result.hasPrefix("<!DOCTYPE") {
                    returnMessage = "Error: return data corrupted, please contact administrator."
                    returnResult = 0
                }
                    // ========== RESPONSE SUCCESS ===========
                else if result == "agree" {
                    returnResult = 1
                }
                    // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                else {
                    returnMessage = "Error: return data corrupted, please contact administrator. message: " + result
                    returnResult = 0
                }
            }
            else {
                returnMessage = "response == null"
                returnResult = 0
            }
            
            if returnResult == 1 {
                DispatchQueue.main.async(execute: { () -> Void in
                    self.loadingProgress.stopAnimating()
                    // set segue to new page here
                    // nonokyo: set here
                    self.isCheckAgreement = "agree"
                    DataFactory.IS_LOADING_FIRSTTIME = true
                    self.performSegue(withIdentifier: "segue_agreement_to_loading", sender: nil)
                })
            }
            else {
                DispatchQueue.main.async(execute: { () -> Void in
                    self.loadingProgress.stopAnimating()
                    Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: returnMessage, isCloseApplication: true)
                })
            }
        }
        task.resume()
    }
    
    
    @IBAction func bAgreeClicked(_ sender: UIButton) {
        if isCheckAgreement == "disagree"{
            submitAccountConsent()
        }
        
    }
    
    @IBAction func bDisagreeClicked(_ sender: UIButton) {
        // when user click disagree
        exit(0)
    }
    
    @IBAction func bAgreementLinkClicked(_ sender: UIButton) {
        UIApplication.shared.open(URL(string: "https://www.nstda.or.th/th/97-about-us/about-us/547-nstda-privacy-policily")!, options: [:], completionHandler: nil)
        
    }
    
    /**
     * Called when the user click on the view (outside the UITextField).
     */
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        self.view.endEditing(true)
    }
    
    @objc func keyboardWillShow(notification: NSNotification) {
        if let keyboardSize = (notification.userInfo?[UIResponder.keyboardFrameEndUserInfoKey] as? NSValue)?.cgRectValue {
            if self.view.frame.origin.y == 0 {
                self.view.frame.origin.y -= keyboardSize.height
            }
        }
    }
    
    @objc func keyboardWillHide(notification: NSNotification) {
        if self.view.frame.origin.y != 0 {
            self.view.frame.origin.y = 0
        }
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "segue_exit_agreement_to_loading"{
            let LoadingController = segue.destination as! LoadingController
            //LoadingController.isCheckAgreement = self.isCheckAgreement
        }
    }
    
}
