//
//  CaptureFaceController.swift
//  TIME
//
//  Created by Sruit Angkavanitsuk on 2/7/20.
//  Copyright © 2020 NSTDA. All rights reserved.
//

import UIKit
import AVKit
//import Vision
//import ARKit
//import CoreML
//import SceneKit
import Toast_Swift
import UICountingLabel

class CaptureFaceController: UIViewController, /*ARSCNViewDelegate,*/
AVCaptureVideoDataOutputSampleBufferDelegate, AVCapturePhotoCaptureDelegate /*, ARSessionDelegate*/ {
    
    var appDelegate:AppDelegate!
    var from_code = ""
    var forthData = "" // from register 2
    var threeData = "" // form update account
    var empID = "" //form update account && checkin
    private var twoData = "" // use for func.failedUpdalodImage
    
    var isFirstTime = true
    var isFaceTrackingEnable = false
    var idleCheck:DispatchWorkItem!
    
    //Camera Capture requiered properties
    var photoDataOutput: AVCapturePhotoOutput!
    var previewLayer:AVCaptureVideoPreviewLayer!
    var captureDevice : AVCaptureDevice!
    let session = AVCaptureSession()
    
    var is_auto_capture = false
    var is_capture = false // on capture processing
    var is_capture_finished = false // reach target of images to capture
    var last_capture_time:Int64 = 0
    var capture_count = 0
    var is_success = true
    var is_closing = false
    
    @IBOutlet weak var vCamera: UIView!
    
    // not support today technology yet [iOS 11+, iPhone 7s+, and camera = high quality]
    //@IBOutlet weak var sceneView: ARSCNView!
    @IBOutlet weak var vImageBorder: UIView!
    @IBOutlet weak var vCaptureButton: UIView!
    @IBOutlet weak var lCountdown: UICountingLabel!
    
    @IBOutlet weak var vPreview1: UIView!
    @IBOutlet weak var ivPreview1: UIImageView!
    @IBOutlet weak var vPreview2: UIView!
    @IBOutlet weak var ivPreview2: UIImageView!
    @IBOutlet weak var vPreview3: UIView!
    @IBOutlet weak var ivPreview3: UIImageView!
    @IBOutlet weak var vPreview4: UIView!
    @IBOutlet weak var ivPreview4: UIImageView!
    @IBOutlet weak var vPreview5: UIView!
    @IBOutlet weak var ivPreview5: UIImageView!
    @IBOutlet weak var vPreview6: UIView!
    @IBOutlet weak var ivPreview6: UIImageView!
    
    fileprivate var loadingProgress : UIActivityIndicatorView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        appDelegate = UIApplication.shared.delegate as! AppDelegate
        if #available(iOS 13.0, *) {
            overrideUserInterfaceStyle = .light // force light mode
        }
        
        if from_code == "CHECKIN" {
            vCaptureButton.isHidden = true
            is_auto_capture = true
            lCountdown.format = "%d"
            lCountdown.method = UILabelCountingMethod.linear
            lCountdown.text = "3"
            lCountdown.animationDuration = 1.5
            lCountdown.completionBlock = {
                self.lCountdown.isHidden = true
                self.captureImage()
            }
        }
        else {
            vCaptureButton.isHidden = false
            is_auto_capture = false
            lCountdown.isHidden = true
        }
        
        vImageBorder.layer.masksToBounds = true
        vImageBorder.layer.borderColor = UIColor( red: 0, green: 1, blue:0, alpha: 1.0 ).cgColor
        vImageBorder.layer.borderWidth = 1.0

        NotificationCenter.default.addObserver(
            self,
            selector: #selector(applicationWillResignActive),
            name: UIApplication.willResignActiveNotification,
            object: nil)
        
        idleCheck = DispatchWorkItem(block: {
            DataFactory.IS_LOADING_FIRSTTIME = true
            // if stay in this page longer than 300 seconds
            // refresh in 300 sec
            if self.from_code == "CHECKIN" {
                self.performSegue(withIdentifier: "segue_exit_captface_to_loading", sender: nil)
            }
            else if self.from_code == "REGISTER" ||
                self.from_code == "UPDATE" {
                
                // if not submit yet, normal close
                if self.capture_count == 0 {
                    self.performSegue(withIdentifier: "segue_exit_captface_to_loading", sender: nil)
                }
                // submit cancel
                else {
                    let resultFailed = self.submitRegisterFailed()
                    print("resultFailed=\(resultFailed)")
                    self.performSegue(withIdentifier: "segue_exit_captface_to_loading", sender: nil)
                }
            }
        })
        
        // loading animation
        loadingProgress = UIActivityIndicatorView() as UIActivityIndicatorView
        loadingProgress.frame = CGRect(x: 0, y: 0,
                                       width: UIScreen.main.bounds.size.width,
                                       height: UIScreen.main.bounds.size.height)
        loadingProgress.isOpaque = false
        loadingProgress.backgroundColor = UIColor( red: 0.95, green: 0.95, blue: 0.95, alpha: 0.5 )
        loadingProgress.hidesWhenStopped = true
        loadingProgress.style = UIActivityIndicatorView.Style.gray
        view.addSubview(loadingProgress)
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        
        print("viewDidAppear(): empID=\(empID)")
        if isFirstTime {
            isFirstTime = false
            
            self.setupAVCapture()
            
            if (from_code == "CHECKIN") {
                self.lCountdown.isHidden = false
                DispatchQueue.main.asyncAfter(deadline: .now() + 1.0) {
                    self.lCountdown.count(from: 3, to: 1)
                }
            }
            
            // not support today technology yet [iOS 11+, iPhone 7s+, and camera = high quality]
            /*
             sceneView.delegate = self
             sceneView.showsStatistics = false
             if ARFaceTrackingConfiguration.isSupported {
             let configuration = ARFaceTrackingConfiguration()
             configuration.isLightEstimationEnabled = true
             sceneView.session.run(configuration, options: [.resetTracking, .removeExistingAnchors])
             }
             else {
             Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: "อุปกรณ์ของท่านไม่รองรับการตรวจจับใบหน้าโดยอัตโนมัติ กรุณากดปุ่มถ่ายรูป เพื่อบันทึกภาพของท่าน")
             isFaceTrackingEnable = false
             return
             }
             */
        }
    }
    
    /**
     part: camera, face detection and capture
     */
    
    func setupAVCapture(){
        session.sessionPreset = AVCaptureSession.Preset.photo
        guard let device = AVCaptureDevice.default(AVCaptureDevice.DeviceType.builtInWideAngleCamera,
                                                   for: .video,
                                                   position: AVCaptureDevice.Position.front)
            else { return   }
        captureDevice = device
        beginSession()
    }
    
    func beginSession(){
        var deviceInput: AVCaptureDeviceInput!
        
        do {
            deviceInput = try AVCaptureDeviceInput(device: captureDevice)
            guard deviceInput != nil else {
                Dialog.showError(self, title: DataString.TITLE_ERROR_ALERT, detail: "ไม่สามารถเปิดกล้องได้ กรุณาลอง Restart เครื่องแล้วเข้าใช้งานอีกครั้งค่ะ")
                return
            }
            
            if session.canAddInput(deviceInput){
                session.addInput(deviceInput)
            }
            
            photoDataOutput = AVCapturePhotoOutput()
            
            if session.canAddOutput(photoDataOutput){
                session.addOutput(photoDataOutput)
            }
            
            previewLayer = AVCaptureVideoPreviewLayer(session: self.session)
            previewLayer.videoGravity = AVLayerVideoGravity.resizeAspect
            
            let rootLayer :CALayer = self.vCamera.layer
            rootLayer.masksToBounds=true
            previewLayer.frame = rootLayer.bounds
            rootLayer.addSublayer(self.previewLayer)
            session.startRunning()
        } catch let error as NSError {
            deviceInput = nil
            print("error: \(error.localizedDescription)")
        }
    }
    
    func captureOutput(_ output: AVCaptureOutput, didOutput sampleBuffer: CMSampleBuffer, from connection: AVCaptureConnection) {
        // do stuff here
    }
    
    // clean up AVCapture
    func stopCamera(){
        session.stopRunning()
    }
    
    // not support today technology yet [iOS 11+, iPhone 7s+, and camera = high quality]
    /*
     func renderer(_ renderer: SCNSceneRenderer, nodeFor anchor: ARAnchor) -> SCNNode? {
     
     guard let device = sceneView.device else {
     return nil
     }
     
     let faceGeometry = ARSCNFaceGeometry(device: device)
     
     let node = SCNNode(geometry: faceGeometry)
     
     node.geometry?.firstMaterial?.fillMode = .lines
     
     return node
     }
     
     func renderer(_ renderer: SCNSceneRenderer, didUpdate node: SCNNode, for anchor: ARAnchor) {
     guard let faceAnchor = anchor as? ARFaceAnchor,
     let faceGeometry = node.geometry as? ARSCNFaceGeometry else {
     print("not found?")
     return
     }
     
     // stop after capture complete
     if self.is_capture_finished {
     return
     }
     
     faceGeometry.update(from: faceAnchor.geometry)
     
     // capture image every 1 sec
     if Date().millisecondsSince1970 < self.last_capture_time + 1000 {
     //print("skip")
     return
     }
     
     let material = SCNMaterial()
     material.diffuse.contents = UIColor.black
     
     guard let model = try? VNCoreMLModel(for: FaceModel().model) else {
     print("Unable to load model")
     fatalError("Unable to load model")
     }
     
     let coreMlRequest = VNCoreMLRequest(model: model) {request, error in
     guard let results = request.results as? [VNClassificationObservation],
     let topResult = results.first
     else {
     print("Unexpected results")
     fatalError("Unexpected results")
     }
     
     DispatchQueue.main.async(execute: { () -> Void in
     
     //print("found=" + topResult.identifier)
     if !self.is_capture_finished &&
     !self.is_capture &&
     Date().millisecondsSince1970 >= self.last_capture_time + 1000
     {
     self.is_capture = true
     self.last_capture_time = Date().millisecondsSince1970
     self.lMessage.text = "ระบบกำลังบันทึกใบหน้าของท่าน"
     self.capture_count += 1
     print("count=\(self.capture_count)")
     
     guard let pixelBuffer = self.sceneView.session.currentFrame?.capturedImage else { return }
     
     let rawImage = UIImage(pixelBuffer: pixelBuffer)
     let previewImage = rawImage!.resizeImage(targetSize: CGSize(width: 240, height: 300))
     
     switch self.capture_count {
     case 1:
     self.ivPreview1.image = previewImage.rotate(radians: .pi/2)
     self.vPreview1.isHidden = false
     break
     case 2:
     self.ivPreview2.image = previewImage.rotate(radians: .pi/2)
     self.vPreview2.isHidden = false
     break
     case 3:
     self.ivPreview3.image = previewImage.rotate(radians: .pi/2)
     self.vPreview3.isHidden = false
     break
     case 4:
     self.ivPreview4.image = previewImage.rotate(radians: .pi/2)
     self.vPreview4.isHidden = false
     break
     case 5:
     self.ivPreview5.image = previewImage.rotate(radians: .pi/2)
     self.vPreview5.isHidden = false
     break
     case 6:
     self.ivPreview6.image = previewImage.rotate(radians: .pi/2)
     self.vPreview6.isHidden = false
     break
     default:
     break
     }
     
     if self.from_code == "CHECKIN" {
     if (self.capture_count >= 1) {
     self.finishCaptureFace()
     self.is_capture_finished = true
     }
     }
     else if self.from_code == "REGISTER" ||
     self.from_code == "UPDATE" {
     if (self.capture_count >= 6) {
     print("finishCaptureFace()")
     self.finishCaptureFace()
     self.is_capture_finished = true
     }
     }
     
     self.is_capture = false
     }
     })
     }
     
     guard let pixelBuffer = self.sceneView.session.currentFrame?.capturedImage else { return }
     
     let handler = VNImageRequestHandler(cvPixelBuffer: pixelBuffer, options: [:])
     DispatchQueue.global().async {
     do {
     try handler.perform([coreMlRequest])
     } catch {
     print(error)
     }
     }
     }
     */
    
    func finishCaptureFace() {
        print("finishCaptureFace()")
        DispatchQueue.main.async(execute: { () -> Void in
            self.loadingProgress.startAnimating()
        })
        self.view.makeToast("กำลังอัพโหลดข้อมูล", duration: 3.0, position: .center)  //เอามาไว้ข้างนอกเพราะ toast มีการซ้อนทับกันกับ result ข้างใน
        
        // not test yet
        DispatchQueue.main.asyncAfter(deadline: .now() + 1) {
           //self.view.makeToast("กำลังอัพโหลดข้อมูล", duration: 3.0, position: .center)
            
            self.is_success = true
            // ---------------------------------------------
            // 1 times
            if self.from_code == "CHECKIN" {
                print("finishCaptureFace().CHECKIN")
                let result1 = self.submitImage(1, image: self.ivPreview1.image!)
                print("result1=\(result1)")
                if result1 != "SUCCESS" {
                    self.is_success = false
                }
                
                if self.is_success {
                    // compare face true
                    let resultVerifyFace = self.submitCheckinVerifyFace()
                    print("resultVerifyFace=\(resultVerifyFace)")

                    if resultVerifyFace.hasPrefix("SUCCESS:") {
                        let result = resultVerifyFace.substring(fromIndex: 8)
                        let resultData = result.split(separator: "+")
                        let _times = String(resultData[1])
                        let _t = String(resultData[2])
                        
                        DispatchQueue.main.async(execute: { () -> Void in
                            self.loadingProgress.stopAnimating()
                            
                            let alert = UIAlertController(title: "ลงเวลางาน", message: "พนักงานบัญชีชื่อ \(self.empID) ลงเวลาเมื่อ \(_times) น.", preferredStyle: UIAlertController.Style.alert)
                            alert.addAction(UIAlertAction(title: DataString.button_yes, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in
                                
                                // confirm checkin
                                let resultCheckinConfirm = self.submitCheckinConfirm(_times, _t: _t)
                                print("resultCheckinConfirm=\(resultCheckinConfirm)")
                                if resultCheckinConfirm == "SUCCESS" {
                                    DispatchQueue.main.async(execute: { () -> Void in
                                        self.loadingProgress.stopAnimating()
                                        
                                        // set segue to new page here
                                        
                                        /*let alert = UIAlertController(title: "ลงเวลางาน", message: "ลงเวลาสมบูรณ์", preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in
                                            self.view.makeToast("ลงเวลาสมบูรณ์", duration: 3.0, position: .center) { didTap in
                                                if didTap {
                                                    self.closeCaptureFace()
                                                } else {
                                                    self.closeCaptureFace()
                                                }
                                            }
                                        }))
                                        self.present(alert, animated: true, completion: nil)*/
                                        
                                        self.view.makeToast("ลงเวลาสมบูรณ์", duration: 3.0, position: .center) { didTap in
                                           if didTap {
                                               self.closeCaptureFace()
                                           } else {
                                               self.closeCaptureFace()
                                           }
                                        }
                                    })
                                }
                                else {
                                    self.is_success = false
                                    DispatchQueue.main.async(execute: { () -> Void in
                                        self.loadingProgress.stopAnimating()
                                        
                                        // set segue to new page here
                                        let alert = UIAlertController(title: DataString.TITLE_ERROR_ALERT, message: resultCheckinConfirm, preferredStyle: UIAlertController.Style.alert)
                                        alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in

                                            self.closeCaptureFace()
                                        }))
                                        self.present(alert, animated: true, completion: nil)
                                    })
                                }
                            }))
                            self.present(alert, animated: true, completion: nil)
                        })

                        //----
                        
                            
                    }
                    else {
                        self.is_success = false
                        DispatchQueue.main.async(execute: { () -> Void in

                            self.loadingProgress.stopAnimating()
                            
                            if resultVerifyFace.hasPrefix("ERROR"){
                                let alert = UIAlertController(title: DataString.TITLE_ERROR_ALERT, message: resultVerifyFace, preferredStyle: UIAlertController.Style.alert)
                                alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in
                                    
                                    self.closeCaptureFace()
                                }))
                                self.present(alert, animated: true, completion: nil)
                            }
                            else {
                                self.view.makeToast(resultVerifyFace, duration: 3.0, position: .center) { didTap in
                                    if didTap {
                                        self.closeCaptureFace()
                                    } else {
                                        self.closeCaptureFace()
                                    }
                                }
                                //self.showToast(message: resultVerifyFace)
                                //self.view.makeToast(resultVerifyFace , duration: 3.0, position: .center)
                                //self.closeCaptureFace()
                                
                            }
                        })
                    }
                }
            }
                // ---------------------------------------------
                // 6 times
            else if self.from_code == "REGISTER" ||
                self.from_code == "UPDATE" {
                print("finishCaptureFace().REGISTER|UPDATE")
                
                let result1 = self.submitImage(1, image: self.ivPreview1.image!)
                print("result1=\(result1)")
                if result1 != "SUCCESS" {
                    self.is_success = false
                }
                
                let result2 = self.submitImage(2, image: self.ivPreview2.image!)
                print("result2=\(result2)")
                if result2 != "SUCCESS" {
                    self.is_success = false
                }
                
                let result3 = self.submitImage(3, image: self.ivPreview3.image!)
                print("result3=\(result3)")
                if result3 != "SUCCESS" {
                    self.is_success = false
                }
                
                let result4 = self.submitImage(4, image: self.ivPreview4.image!)
                print("result4=\(result4)")
                if result4 != "SUCCESS" {
                    self.is_success = false
                }
                
                let result5 = self.submitImage(5, image: self.ivPreview5.image!)
                print("result5=\(result5)")
                if result5 != "SUCCESS" {
                    self.is_success = false
                }
                
                let result6 = self.submitImage(6, image: self.ivPreview6.image!)
                print("result6=\(result6)")
                if result6 != "SUCCESS" {
                    self.is_success = false
                }
                
                let resultModel = self.submitRegisterModel()
                print("resultModel=\(resultModel)")
                if resultModel != "SUCCESS" {
                    self.is_success = false
                }
                
                if self.is_success {
                    if self.from_code == "REGISTER" {
                        DispatchQueue.main.async(execute: { () -> Void in
                            self.view.makeToast("ลงทะเบียนสมบูรณ์", duration: 3.0, position: .center)
                        })
                        DispatchQueue.main.asyncAfter(deadline: .now() + 1) {
                            self.loadingProgress.stopAnimating()
                            DataFactory.IS_LOADING_FIRSTTIME = true
                            self.performSegue(withIdentifier: "segue_exit_captface_to_loading", sender: nil)
                            //self.performSegue(withIdentifier: "segue_captface_to_signin", sender: nil)
                        }
                    }
                    else if self.from_code == "UPDATE" {
                        DispatchQueue.main.async(execute: { () -> Void in
                            self.view.makeToast("อัพเดทสมบูรณ์", duration: 3.0, position: .center)
                        })
                        DispatchQueue.main.asyncAfter(deadline: .now() + 1) {
                            self.loadingProgress.stopAnimating()
                            self.performSegue(withIdentifier: "segue_exit_captface_to_checkin", sender: nil)
                        }
                    }
                }
                else {
                    let resultFailed = self.submitRegisterFailed()
                    print("resultFailed=\(resultFailed)")
                    
                    if self.from_code == "REGISTER" {
                        if resultFailed == "SUCCESS" {
                            //must have when send photo incomplete 6 images
                            // set segue to new page here
                            DispatchQueue.main.async(execute: { () -> Void in
                                self.loadingProgress.stopAnimating()
                                // set segue to new page here
                                self.view.makeToast("ลงทะเบียนไม่สมบูรณ์ กรุณาลองใหม่", duration: 3.0, position: .center) { didTap in
                                    if didTap {
                                        self.closeCaptureFace()
                                    } else {
                                        self.closeCaptureFace()
                                    }
                                }
                                
                                /*let alert = UIAlertController(title: DataString.TITLE_ERROR_ALERT, message: "ลงทะเบียนไม่สมบูรณ์ กรุณษลองใหม่ค่ะ", preferredStyle: UIAlertController.Style.alert)
                                alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in
                                    
                                    self.closeCaptureFace()
                                }))
                                self.present(alert, animated: true, completion: nil)*/
                           })
                        }
                        else {
                            DispatchQueue.main.async(execute: { () -> Void in
                                self.loadingProgress.stopAnimating()
                                // set segue to new page here
                                self.view.makeToast("ลงทะเบียนไม่สมบูรณ์ กรุณาลองใหม่", duration: 3.0, position: .center) { didTap in
                                    if didTap {
                                        self.closeCaptureFace()
                                    } else {
                                        self.closeCaptureFace()
                                    }
                                }
                                /*let alert = UIAlertController(title: DataString.TITLE_ERROR_ALERT, message: "ลงทะเบียนไม่สมบูรณ์ กรุณาลองใหม่ค่ะ", preferredStyle: UIAlertController.Style.alert)
                                alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in

                                    self.closeCaptureFace()
                                }))
                                self.present(alert, animated: true, completion: nil)*/
                            })
                        }
                        
                    }
                    else if self.from_code == "UPDATE" {
                        if resultFailed == "SUCCESS" {
                            //must have when send photo incomplete 6 images
                            // set segue to new page here
                            DispatchQueue.main.async(execute: { () -> Void in
                                self.loadingProgress.stopAnimating()
                                // set segue to new page here
                                self.view.makeToast("อัพเดทไม่สมบูรณ์ กรุณาลองใหม่", duration: 3.0, position: .center) { didTap in
                                    if didTap {
                                        self.closeCaptureFace()
                                    } else {
                                        self.closeCaptureFace()
                                    }
                                }
                                /*let alert = UIAlertController(title: DataString.TITLE_ERROR_ALERT, message: "อัพเดทไม่สมบูรณ์ กรุณาลองใหม่ค่ะ", preferredStyle: UIAlertController.Style.alert)
                                alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in
                                    
                                    self.closeCaptureFace()
                                }))
                                self.present(alert, animated: true, completion: nil)*/
                                
                           })
                        }
                        else {
                            DispatchQueue.main.async(execute: { () -> Void in
                                self.loadingProgress.stopAnimating()
                                // set segue to new page here
                                self.view.makeToast("อัพเดทไม่สมบูรณ์ กรุณาลองใหม่", duration: 3.0, position: .center) { didTap in
                                    if didTap {
                                        self.closeCaptureFace()
                                    } else {
                                        self.closeCaptureFace()
                                    }
                                }
                                /*let alert = UIAlertController(title: DataString.TITLE_ERROR_ALERT, message: "อัพเดทไม่สมบูรณ์ กรุณาลองใหม่ค่ะ", preferredStyle: UIAlertController.Style.alert)
                                alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in

                                    self.closeCaptureFace()
                                }))
                                self.present(alert, animated: true, completion: nil)*/
                                
                            })
                        }
                    }
                }
            }
        }
    }
    
    /**
     part: connect API
     */
    
    // step 1: capture image
    func submitImage(_ num: Int, image:UIImage) -> String {
        print("submitImage() - image\(num)")
        
        // if some image = false, skip everthing and go to submitfailed()
        if is_success == false {
            return "ERROR: Error from previous"
        }
        
        let semaphore = DispatchSemaphore.init(value: 0)
        var returnResult = 0
        var returnMessage = ""
        
        // url
        // nonokyo: set here
        if self.from_code == "REGISTER" {
            // url
            // nonokyo: set here
            let url = DataFactory.SUBMIT_API_ACCOUNT_REGISTER_UPLOAD_IMAGE_URL
            let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
            request.httpMethod = "POST"
            request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
            
            let username = forthData.split(separator: "+")[1]
            let fileName = "CaptureImage\(num)_\(username)_.jpg"
            
            
            if DataFactory.DEBUG {
                print("fileName=\n\(fileName)")
            }
            
            // post data
            // nonokyo: set here
            let postData = DataFactory.generatePostData(
                [DataFactory.GeneratePostObject(name: "data_bytes64Sting", value: EncryptDecryptAlgorithm.EncryptData(image.imageTobase64())),
                 DataFactory.GeneratePostObject(name: "data_bytes64StingK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
                 DataFactory.GeneratePostObject(name: "data_imageFileName",value:EncryptDecryptAlgorithm.EncryptData(fileName)),
                 DataFactory.GeneratePostObject(name: "data_imageFileNameK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
            )
            // display sent data
            if DataFactory.DEBUG {
                print("url=\(request.url!)")
                // too large
                //print("data=\n\(postData)")
            }
            request.httpBody = postData.data(using: String.Encoding.utf8)
            
            let session = URLSession.shared
            let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
                
                if error != nil {
                    if DataFactory.DEBUG {
                        print("ERROR: \(error!)")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: error=\(error!)"
                    do { semaphore.signal() }
                    return
                }
                
                let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
                if DataFactory.DEBUG {
                    print("result=\(result)")
                }
                
                if !result.isEmpty {
                    // ========== RESPONSE SUCCESS ===========
                    if result == "Complete" {
                        returnResult = 1
                        returnMessage = "SUCCESS"
                        do { semaphore.signal() }
                    }
                    else {
                        if DataFactory.DEBUG {
                            print("ERROR: result=\(result)")
                        }
                        returnResult = 0
                        returnMessage = "ERROR: result=\(result)"
                        do { semaphore.signal() }
                    }
                }
                else {
                    if DataFactory.DEBUG {
                        print("ERROR: response == null")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: response == null"
                    do { semaphore.signal() }
                }
            })
            task.resume()
        }
        else if self.from_code == "UPDATE" {
            
            let  url = DataFactory.SUBMIT_API_ACCOUNT_UPDATE_UPLOAD_IMAGE_URL
            // nonokyo: set here
            let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
            request.httpMethod = "POST"
            request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
            
            let username = threeData.split(separator: "+")[1]
            let fileName = "CaptureImage\(num)_\(username)_.jpg"
            
            if DataFactory.DEBUG {
                print("fileName=\n\(fileName)")
            }
            
            // post data
            // nonokyo: set here
            let postData = DataFactory.generatePostData(
                [DataFactory.GeneratePostObject(name: "data_bytes64Sting", value: EncryptDecryptAlgorithm.EncryptData(image.imageTobase64())),
                 DataFactory.GeneratePostObject(name: "data_bytes64StingK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
                 DataFactory.GeneratePostObject(name: "imageFileName",value:EncryptDecryptAlgorithm.EncryptData(fileName)),
                 DataFactory.GeneratePostObject(name: "imageFileNameK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
            )
            // display sent data
            if DataFactory.DEBUG {
                print("url=\(request.url!)")
                // too large
                //print("data=\n\(postData)")
            }
            request.httpBody = postData.data(using: String.Encoding.utf8)
            
            let session = URLSession.shared
            let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
                
                if error != nil {
                    if DataFactory.DEBUG {
                        print("ERROR: \(error!)")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: error=\(error!)"
                    do { semaphore.signal() }
                    return
                }
                
                let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
                if DataFactory.DEBUG {
                    print("result=\(result)")
                }
                
                if !result.isEmpty {
                    // ========== RESPONSE SUCCESS ===========
                    if result == "Complete" {
                        returnResult = 1
                        returnMessage = "SUCCESS"
                        do { semaphore.signal() }
                    }
                    else {
                        if DataFactory.DEBUG {
                            print("ERROR: result=\(result)")
                        }
                        returnResult = 0
                        returnMessage = "ERROR: result=\(result)"
                        do { semaphore.signal() }
                    }
                }
                else {
                    if DataFactory.DEBUG {
                        print("ERROR: response == null")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: response == null"
                    do { semaphore.signal() }
                }
            })
            task.resume()
            
        }
        else if self.from_code == "CHECKIN" {
            
            let  url = DataFactory.SUBMIT_API_ACCOUNT_CHECKIN_UPLOAD_IMAGE_URL
            // nonokyo: set here
            let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
            request.httpMethod = "POST"
            request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
            
            // set data
            let macAdr = appDelegate.UUID
            let fileName = "CaptureImage_\(empID)_\(macAdr)_.jpg"
            
            if DataFactory.DEBUG {
                print("fileName=\n\(fileName)")
            }
            
            // post data
            // nonokyo: set here
            let postData = DataFactory.generatePostData(
                [DataFactory.GeneratePostObject(name: "_bytes64Sting_data", value: EncryptDecryptAlgorithm.EncryptData(image.imageTobase64())),
                 DataFactory.GeneratePostObject(name: "_bytes64StingK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
                 DataFactory.GeneratePostObject(name: "_imageFileName_data",value:EncryptDecryptAlgorithm.EncryptData(fileName)),
                 DataFactory.GeneratePostObject(name: "_imageFileNameK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
            )
            // display sent data
            if DataFactory.DEBUG {
                print("url=\(request.url!)")
                // too large
                //print("data=\n\(postData)")
            }
            request.httpBody = postData.data(using: String.Encoding.utf8)
            
            let session = URLSession.shared
            let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
                
                if error != nil {
                    if DataFactory.DEBUG {
                        print("ERROR: \(error!)")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: error=\(error!)"
                    do { semaphore.signal() }
                    return
                }
                
                let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
                if DataFactory.DEBUG {
                    print("result=\(result)")
                }
                
                if !result.isEmpty {
                    // ========== RESPONSE SUCCESS ===========
                    if result == "Complete\n" {
                        returnResult = 1
                        returnMessage = "SUCCESS"
                        do { semaphore.signal() }
                    }
                    else {
                        if DataFactory.DEBUG {
                            print("ERROR: result=\(result)")
                        }
                        returnResult = 0
                        returnMessage = "ERROR: result=\(result)"
                        do { semaphore.signal() }
                    }
                }
                else {
                    if DataFactory.DEBUG {
                        print("ERROR: response == null")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: response == null"
                    do { semaphore.signal() }
                }
            })
            task.resume()
        }
        
        semaphore.wait()
        
        if returnResult == 1 {
            return returnMessage // "SUCCESS"
        }
        else {
            return returnMessage
        }
    }
    
    // step 2a: submit model [only REGISTER, UPDATE]
    func submitRegisterModel() -> String {
        print("submitRegisterModel()")
        
        // if some image = false, skip everthing and go to submitfailed()
        if is_success == false {
            return "ERROR: Error from previous"
        }
        
        let semaphore = DispatchSemaphore.init(value: 0)
        var returnResult = 0
        var returnMessage = ""
        
        if self.from_code == "REGISTER" {
            // submitEnrollModel
            let url = DataFactory.SUBMIT_API_ACCOUNT_REGISTER_MODEL_URL
            
            let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
            request.httpMethod = "POST"
            request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
            
            // post data
            // nonokyo: set here
            let postData = DataFactory.generatePostData(
                [DataFactory.GeneratePostObject(name: "data_five", value: EncryptDecryptAlgorithm.EncryptData("\(forthData)+\(appDelegate.UUID)")),
                 DataFactory.GeneratePostObject(name: "data_fiveK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
                 DataFactory.GeneratePostObject(name: "data_Mac",value:EncryptDecryptAlgorithm.EncryptData(appDelegate.UUID)),
                 DataFactory.GeneratePostObject(name: "data_MacK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
            )
            // display sent data
            if DataFactory.DEBUG {
                print("url=\(request.url!)")
                print("data=\n\(postData)")
            }
            request.httpBody = postData.data(using: String.Encoding.utf8)
            
            let session = URLSession.shared
            let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
                
                if error != nil {
                    if DataFactory.DEBUG {
                        print("ERROR: \(error!)")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: error=\(error!)"
                    do { semaphore.signal() }
                    return
                }
                
                //var statusEnroll = ""
                let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
                if DataFactory.DEBUG {
                    print("result=\(result)")
                }
                
                if !result.isEmpty {
                    // ========== RESPONSE SUCCESS ===========
                    if result == "Add New Person Complete" {
                        returnResult = 1
                        returnMessage = "SUCCESS"
                        do { semaphore.signal() }
                        //statusEnroll = "Enrolled"
                    }
                    else {
                        returnResult = 0
                        returnMessage = "ERROR: result=\(result)"
                        do { semaphore.signal() }
                    }
                }
                else {
                    if DataFactory.DEBUG {
                        print("ERROR: response == null")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: response == null"
                    do { semaphore.signal() }
                }
            })
            task.resume()
        }
        else if self.from_code == "UPDATE" {
            //submitUpdateModel
            let url = DataFactory.SUBMIT_API_ACCOUNT_UPDATE_MODEL_URL
            let Statue = "8";
            let username = threeData.split(separator: "+")[1]
            let twoData = Statue + "+" + username
            
            if DataFactory.DEBUG {
                print("dataTwo=\n\(twoData)")
            }
            
            let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
            request.httpMethod = "POST"
            request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
            
            // post data
            // nonokyo: set here
            let postData = DataFactory.generatePostData(
                [DataFactory.GeneratePostObject(name: "data_two", value: EncryptDecryptAlgorithm.EncryptData(twoData)),
                 DataFactory.GeneratePostObject(name: "data_twoK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
            )
            // display sent data
            if DataFactory.DEBUG {
                print("url=\(request.url!)")
                print("data=\n\(postData)")
            }
            request.httpBody = postData.data(using: String.Encoding.utf8)
            
            let session = URLSession.shared
            let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
                
                if error != nil {
                    if DataFactory.DEBUG {
                        print("ERROR: \(error!)")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: error=\(error!)"
                    do { semaphore.signal() }
                    return
                }
                
               
                //var statusUpload = ""
                let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
                if DataFactory.DEBUG {
                    print("result=\(result)")
                }
                
                if !result.isEmpty {
                    // ========== RESPONSE SUCCESS ===========
                    if result == "Update Complete" {
                        returnResult = 1
                        returnMessage = "SUCCESS"
                        do { semaphore.signal() }
                        //statusUpload = "Updated"
                        //returnMessage = "อัพเดตสมบูรณ์"
                    }
                    else if result == "Some Face Image Low Quality.Update Again" {
                        returnResult = 0
                        returnMessage = "ERROR: result=\(result)"
                        do { semaphore.signal() }
                        //completion("ERROR: FAILED UPLOAD")
                        //returnMessage = "อัพเดตไม่สมบูรณ์...กรุณาลองใหม๋"
                    }
                    else {
                        if DataFactory.DEBUG {
                            print("ERROR: result=\(result)")
                        }
                        returnResult = 0
                        returnMessage = "ERROR: result=\(result)"
                        do { semaphore.signal() }
                    }
                }
                else {
                    if DataFactory.DEBUG {
                        print("ERROR: response == null")
                    }
                    returnResult = 0
                    returnMessage = "ERROR: response == null"
                    do { semaphore.signal() }
                }
            })
            task.resume()
            
        }
        
        semaphore.wait()
        
        if returnResult == 1 {
            return returnMessage
        }
        else {
            return returnMessage
        }
    }
    
    // step 2b: submit checkin [only CHECKIN]
    // status = 4
    func submitCheckinVerifyFace() -> String {
        print("submitCheckinVerifyFace()")
        
        let semaphore = DispatchSemaphore.init(value: 0)
        var returnResult = 0
        var returnMessage = ""
        
        let  url = DataFactory.SUBMIT_API_ACCOUNT_CHECKIN_VERIFY_FACE_URL
        // nonokyo: set here
        let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
        request.httpMethod = "POST"
        request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
        
        // set data
        let macAdr = appDelegate.UUID
        let status = "4"
        let threeData = "\(status)+\(macAdr)+\(empID)"
        
        if DataFactory.DEBUG {
            print("threeData=\n\(threeData)")
            print("macAdr=\n\(macAdr)")
        }
        
        // post data
        // nonokyo: set here
        let postData = DataFactory.generatePostData(
            [DataFactory.GeneratePostObject(name: "Three_data", value: EncryptDecryptAlgorithm.EncryptData(threeData)),
             DataFactory.GeneratePostObject(name: "ThreeK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
        )
        // display sent data
        if DataFactory.DEBUG {
            print("url=\(request.url!)")
            print("data=\n\(postData)")
        }
        request.httpBody = postData.data(using: String.Encoding.utf8)
        
        let session = URLSession.shared
        let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
            
            if error != nil {
                if DataFactory.DEBUG {
                    print("ERROR: \(error!)")
                }
                returnResult = 0
                returnMessage = "ERROR: error=\(error!)"
                do { semaphore.signal() }
                return
            }
            
            //var _times = ""
            
            let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
            if DataFactory.DEBUG {
                print("result=\(result)")
            }
            
            if !result.isEmpty {
                // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                if result.hasPrefix("<!DOCTYPE") {
                    returnMessage = "Error: return data corrupted, please contact administrator."
                    returnResult = 0
                }
                    // ========== RESPONSE ERROR =============
                else if result == "Unknown Person !!!"{
                    returnMessage = "ไม่รู้จักใบหน้านี้ กดปุ่มลงเวลาเพื่อสแกนใบหน้าและบันทึกเวลาอีกครั้ง"
                    returnResult = 0
                    self.capture_count = 0
                    self.vPreview1.isHidden = true
                }
                else if result == "Some Face Image Low Quality.Enroll Again" {
                    returnMessage = "ภาพใบหน้าคุณภาพตำ่, กดปุ่มลงเวลาลองอีกครั้ง"
                    returnResult = 0
                }
                else if result == "Face Image Low Quality.Try Again" {
                    returnMessage = "ภาพใบหน้าคุณภาพตำ่, กดปุ่มลงเวลาลองอีกครั้ง"
                    returnResult = 0
                }
                    
                    // ========== RESPONSE SUCCESS ===========
                else {
                    let resultData = result.split(separator: "+")
                    if resultData.count == 3 {
                        //_times = String(resultData[1])
                        //_t = String(resultData[2])
                        returnMessage = "SUCCESS:\(result)"
                        returnResult = 1
                    }
                        // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                    else {
                        returnMessage = "Error: return data corrupted, please contact administrator. message: " + result
                        returnResult = 0
                    }
                }
            }
            else {
                if DataFactory.DEBUG {
                    print("ERROR: response == null")
                }
                returnResult = 0
            }

            do { semaphore.signal() }
        })
        task.resume()
        
        semaphore.wait()
        
        if returnResult == 1 {
            return returnMessage
        }
        else {
            return returnMessage
        }
    }
    
    // step 3b: confirm checkin [only CHECKIN]
    func submitCheckinConfirm(_ _times: String, _t: String) -> String {
        print("submitCheckinConfirm()")
        
        let semaphore = DispatchSemaphore.init(value: 0)
        var returnResult = 0
        var returnMessage = ""
        
        let  url = DataFactory.SUBMIT_API_ACCOUNT_CHECKIN_CONFIRM_URL
        // nonokyo: set here
        let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
        request.httpMethod = "POST"
        request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
        
        // set data
        let macAdr = appDelegate.UUID
        //let status = "4"
        let data_CurrentString = "\(self.empID)+\(_times)+\(_t)"
        let bssid = DataFactory.CURRENT_BSSID // ptoon: pending
        let publicIP = appDelegate.publicIP
        let privateIP = appDelegate.privateIP
        
        if DataFactory.DEBUG {
            print("threeData=\n\(threeData)")
            print("macAdr=\n\(macAdr)")
        }
        
        // post data
        // nonokyo: set here
        let postData = DataFactory.generatePostData(
            [DataFactory.GeneratePostObject(name: "data_CurrentString", value: EncryptDecryptAlgorithm.EncryptData(data_CurrentString)),
             DataFactory.GeneratePostObject(name: "data_CurrentStringK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
             DataFactory.GeneratePostObject(name: "data_pubipKeep", value: EncryptDecryptAlgorithm.EncryptData(publicIP)),
             DataFactory.GeneratePostObject(name: "data_pubipKeepK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
             DataFactory.GeneratePostObject(name: "data_privateipKeep", value: EncryptDecryptAlgorithm.EncryptData(privateIP)),
             DataFactory.GeneratePostObject(name: "data_privateipKeepK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
             DataFactory.GeneratePostObject(name: "data_WifiBSSIDKeep", value: EncryptDecryptAlgorithm.EncryptData(bssid)),
             DataFactory.GeneratePostObject(name: "data_WifiBSSIDKeepK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
             DataFactory.GeneratePostObject(name: "data_getMacAddr", value: EncryptDecryptAlgorithm.EncryptData(macAdr)),
             DataFactory.GeneratePostObject(name: "data_getMacAddrK", value: EncryptDecryptAlgorithm.getKeyEncrypt()),
            ]
        )
        // display sent data
        if DataFactory.DEBUG {
            print("url=\(request.url!)")
            print("data=\n\(postData)")
        }
        request.httpBody = postData.data(using: String.Encoding.utf8)
        
        let session = URLSession.shared
        let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
            
            if error != nil {
                if DataFactory.DEBUG {
                    print("ERROR: \(error!)")
                }
                returnResult = 0
                returnMessage = "ERROR: error=\(error!)"
                do { semaphore.signal() }
                return
            }
            
            let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
            if DataFactory.DEBUG {
                print("result=\(result)")
            }
            
            if !result.isEmpty {
                // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                if result.hasPrefix("<!DOCTYPE") {
                    returnMessage = "Error: return data corrupted, please contact administrator."
                    returnResult = 0
                }
                    // ========== RESPONSE SUCCESS ===========
                else if result == "ServerAlreadyRecordTime" {
                    returnMessage = "SUCCESS"
                    returnResult = 1
                }
                    // ========== RESPONSE UNKNOWN / DATA CORRUPTED ===========
                else {
                    returnMessage = "ไม่สามารถลงเวลาได้ กรุณาลองใหม่อีกครั้ง"
                    returnResult = 0
                }
            }
            else {
                if DataFactory.DEBUG {
                    print("result=\(result)")
                }
                returnResult = 0
            }

            do { semaphore.signal() }
        })
        task.resume()
        
        semaphore.wait()
        
        if returnResult == 1 {
            return returnMessage
        }
        else {
            return returnMessage
        }
    }
    
    // step 3a: canceled submit [only REGISTER, UPDATE]
    func submitRegisterFailed() -> String {
        print("submitRegisterFailed()")
        
        let semaphore = DispatchSemaphore.init(value: 0)
        var returnResult = 0
        var returnMessage = ""
        
        var url = ""
        var empidforDir = ""
        let status = "NoSixFace"
        // url
        // nonokyo: set here
        if(self.from_code == "REGISTER"){
            
            url = DataFactory.SUBMIT_API_ACCOUNT_REGISTER_CANCEL_URL
            empidforDir = String(forthData.split(separator: "+")[1])
            twoData = "\(status)+\(empidforDir)+\(appDelegate.UUID)"
        }
        else if (self.from_code == "UPDATE"){
            
            url = DataFactory.SUBMIT_API_ACCOUNT_UPDATE_CANCEL_URL
            empidforDir = String(threeData.split(separator: "+")[1])
            twoData = "\(status)+\(empidforDir)"
        }
        
        if DataFactory.DEBUG {
            print("dataTwo=\(twoData)")
        }
        
        let request:NSMutableURLRequest = NSMutableURLRequest(url: URL(string: url)!)
        request.httpMethod = "POST"
        request.addValue("multipart/form-data; boundary=X", forHTTPHeaderField: "Content-Type")
        
        // post data
        // nonokyo: set here
        let postData = DataFactory.generatePostData(
            [DataFactory.GeneratePostObject(name: "data_NoSixFace", value: EncryptDecryptAlgorithm.EncryptData(twoData)),
             DataFactory.GeneratePostObject(name: "data_NoSixFaceK", value: EncryptDecryptAlgorithm.getKeyEncrypt())]
        )
        // display sent data
        if DataFactory.DEBUG {
            print("url=\(request.url!)")
            print("data=\n\(postData)")
        }
        request.httpBody = postData.data(using: String.Encoding.utf8)
        let session = URLSession.shared
        let task = session.dataTask(with: request as URLRequest, completionHandler: {(data, response, error) -> Void in
            
            if error != nil {
                if DataFactory.DEBUG {
                    print("ERROR: \(error!)")
                }
                returnResult = 0
                returnMessage = "ERROR: error=\(error!)"
                do { semaphore.signal() }
                return
            }
            
            let result = NSString(data: data!, encoding: String.Encoding.utf8.rawValue)! as String
            if DataFactory.DEBUG {
                print("result=\(result)")
            }
            
            if !result.isEmpty {
                // ========== RESPONSE SUCCESS ===========
                if result == "EnrollSixFaceStatus" {
                    returnMessage =  "SUCCESS"
                    returnResult = 1
                    print("result=\(result)")
                }
                else if result == "UpdateSixFaceStatus"{
                    returnMessage = "SUCCESS"
                    returnResult = 1
                    print("result=\(result)")
                }
                else if result.hasPrefix("<!DOCTYPE") {
                    returnMessage = "Error: return data corrupted, please contact administrator."
                    returnResult = 0
                }
                else {
                    if DataFactory.DEBUG {
                        print("ERROR: result=\(result)")
                    }
                    returnMessage = "ERROR: result=" + result
                    returnResult = 0
                }
            }
            else {
                if DataFactory.DEBUG {
                    print("ERROR: response == null")
                }
                returnMessage = "ERROR: result=" + result
                returnResult = 0
            }

            do { semaphore.signal() }
            
        })
        task.resume()
        
        semaphore.wait()
        
        if returnResult == 1 {
            return returnMessage
        }
        else {
            return returnMessage
        }
    }
    
    /**
     part: etc
     */
    @IBAction func bCaptureClicked(_ sender: UIButton) {
        print("bCaptureClicked()")
        
        // stop after capture complete
        if self.is_capture_finished {
            return
        }
        
        // capture image every 0.75 sec
        if Date().millisecondsSince1970 < self.last_capture_time + 750 {
            return
        }
        
        captureImage()
    }
    
    func captureImage() {
        if (!is_closing) {
            let photoDataSetting = AVCapturePhotoSettings()
            let previewPixelType = photoDataSetting.availablePreviewPhotoPixelFormatTypes.first!
            let previewFormat = [kCVPixelBufferPixelFormatTypeKey as String: previewPixelType,
                                 kCVPixelBufferWidthKey as String: 960,
                                 kCVPixelBufferHeightKey as String: 1280]
            photoDataSetting.previewPhotoFormat = previewFormat
            self.photoDataOutput.capturePhoto(with: photoDataSetting, delegate: self)
        }
    }
    
    func photoOutput(_ output: AVCapturePhotoOutput, didFinishProcessingPhoto photoSampleBuffer: CMSampleBuffer?, previewPhoto previewPhotoSampleBuffer: CMSampleBuffer?, resolvedSettings: AVCaptureResolvedPhotoSettings, bracketSettings: AVCaptureBracketedStillImageSettings?, error: Error?) {
        print("photoOutput()")
        if let error = error {
            self.view.makeToast("ERROR: \(error.localizedDescription)", duration: 3.0, position: .bottom)
            return
        }
        
        if let sampleBuffer = photoSampleBuffer, let previewBuffer = previewPhotoSampleBuffer, let dataImage = AVCapturePhotoOutput.jpegPhotoDataRepresentation(forJPEGSampleBuffer: sampleBuffer, previewPhotoSampleBuffer: previewBuffer) {
            
            if !self.is_capture_finished &&
                !self.is_capture &&
                Date().millisecondsSince1970 >= self.last_capture_time + 1000
            {
                self.is_capture = true
                self.last_capture_time = Date().millisecondsSince1970
                //self.view.makeToast("ระบบกำลังบันทึกใบหน้าของท่าน", duration: 0.8, position: .center)
                //self.lMessage.text = "ระบบกำลังบันทึกใบหน้าของท่าน"
                self.capture_count += 1
                print("count=\(self.capture_count)")
                var rawImage = UIImage(data: dataImage)!
                rawImage = rawImage.fixOrientation() // fix image orientation in ipad
                print("image size: \(rawImage.size.width),\(rawImage.size.height)")
                let cropWidth = rawImage.size.width * 0.6
                let cropHeight = cropWidth / 4.0 * 5.0
                print("crop size: \((rawImage.size.width/2) - (cropWidth / 2)), \((rawImage.size.height/2) - (cropHeight / 2)), \(cropWidth),\(cropHeight)")
                let cropImage = rawImage.cropImage(toRect: CGRect(
                    x: (rawImage.size.width/2) - (cropWidth / 2),
                    y: (rawImage.size.height/2) - (cropHeight / 2),
                    width: cropWidth,
                    height: cropHeight
                ))
                var previewImage = cropImage.resizeImage(targetSize: CGSize(width: 360, height: 450))
                previewImage = previewImage.withHorizontallyFlippedOrientation() // fix mirror image
                
                switch self.capture_count {
                case 1:
                    self.ivPreview1.image = previewImage //.rotate(radians: .pi/2)
                    self.vPreview1.isHidden = false
                    break
                case 2:
                    self.ivPreview2.image = previewImage //.rotate(radians: .pi/2)
                    self.vPreview2.isHidden = false
                    break
                case 3:
                    self.ivPreview3.image = previewImage //.rotate(radians: .pi/2)
                    self.vPreview3.isHidden = false
                    break
                case 4:
                    self.ivPreview4.image = previewImage //.rotate(radians: .pi/2)
                    self.vPreview4.isHidden = false
                    break
                case 5:
                    self.ivPreview5.image = previewImage //.rotate(radians: .pi/2)
                    self.vPreview5.isHidden = false
                    break
                case 6:
                    self.ivPreview6.image = previewImage //.rotate(radians: .pi/2)
                    self.vPreview6.isHidden = false
                    break
                default:
                    break
                }
                
                if self.from_code == "CHECKIN" {
                    if (self.capture_count >= 1) {
                        self.finishCaptureFace()
                        self.is_capture_finished = true
                    }
                }
                else if self.from_code == "REGISTER" ||
                    self.from_code == "UPDATE" {
                    if (self.capture_count >= 6) {
                        print("finishCaptureFace()")
                        self.finishCaptureFace()
                        self.is_capture_finished = true
                    }
                }
                
                self.is_capture = false
            }
            
        }
    }
    
    override func viewWillAppear(_ animated: Bool) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 300, execute: idleCheck)
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        idleCheck.cancel()
    }
    
    @IBAction func bCloseClicked(_ sender: UIButton) {
        if from_code == "CHECKIN" {
            self.closeCaptureFace()
        }
        else if self.from_code == "REGISTER" ||
            self.from_code == "UPDATE" {
            
            // if not submit yet, normal close
            if self.capture_count == 0 {
                self.closeCaptureFace()
            }
            // submit cancel
            else {
                let resultFailed = self.submitRegisterFailed()
                print("resultFailed=\(resultFailed)")
                self.closeCaptureFace()
            }
        }
    }
    
    func closeCaptureFace() {
        if !is_closing {
            is_closing = true
            if from_code == "CHECKIN" || from_code == "UPDATE" {
                self.performSegue(withIdentifier: "segue_exit_captface_to_checkin", sender: nil)
            }
            else if from_code == "REGISTER"  {
                self.performSegue(withIdentifier: "segue_exit_captface_toregister1", sender: nil) //edit follow แก้ไข2 ข้อ 7
                //self.performSegue(withIdentifier: "segue_exit_captface_to_captprepare", sender: nil)
            }
        }
    }
    
    @objc func applicationWillResignActive() {
        NSLog("CaptureFaceController lost focus")
        closeCaptureFace()
    }
    
    deinit {
        NotificationCenter.default.removeObserver(self)
    }
    
    
    //function custom toast
    func showToast(message: String) {
        guard let window = UIApplication.shared.keyWindow else {
            return
        }
        let toastLbl = UILabel()
        toastLbl.text = message
        toastLbl.textAlignment = .center
        toastLbl.font = UIFont.systemFont(ofSize: 16)
        toastLbl.textColor = UIColor.white
        toastLbl.backgroundColor = UIColor.black //.withAlphaComponent(0.5)
        toastLbl.numberOfLines = 0

        let textSize = toastLbl.intrinsicContentSize
        let labelHeight = ( textSize.width / window.frame.width ) * 30
        let labelWidth = min(textSize.width, window.frame.width - 205)
        let adjustedHeight = max(labelHeight, textSize.height + 35)
        
        toastLbl.frame = CGRect(x: 20, y: (window.frame.height - 200 ) - adjustedHeight, width: labelWidth + 35, height: adjustedHeight)
        toastLbl.center.x = window.center.x
        //toastLbl.center = self.view.center
        toastLbl.layer.cornerRadius = 10
        toastLbl.layer.masksToBounds = true

        window.addSubview(toastLbl)
        
        UIView.animate(withDuration: 3.5, animations: {
            toastLbl.alpha = 0
        }) { (_) in
            toastLbl.removeFromSuperview()
        }
    }
    
}
