//
//  Register3Controller.swift
//  TIME
//
//  Created by Sruit Angkavanitsuk on 2/7/20.
//  Copyright © 2020 NSTDA. All rights reserved.
//

import UIKit
import AVKit

class CapturePrepareController: UIViewController {
    
    var from_code = ""
    var forthData = "" // from register 2
    var threeData = "" // form update account
    var empID = "" // form update account
    
    @IBOutlet weak var ivLogo: UIImageView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        if #available(iOS 13.0, *) {
            overrideUserInterfaceStyle = .light // force light mode
        }
        // Do any additional setup after loading the view.
        
        // loading view
        if DataFactory.BUSINESS_CODE == 1 {
            ivLogo.image = UIImage(named: "i_nectec_capture_prepare")
        }
        else if DataFactory.BUSINESS_CODE == 2 {
            ivLogo.image = UIImage(named: "i_nbtc_capture_prepare")
        }
        
        
        //Camera
        AVCaptureDevice.requestAccess(for: .video) { response in
            if response {
                //access granted
            } else {

            }
        }

    }
    
    @IBAction func bCaptureClicked(_ sender: UIButton) {
        DispatchQueue.main.async(execute: { () -> Void in
            self.performSegue(withIdentifier: "segue_captprepare_to_captface", sender: nil)
        })
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "segue_captprepare_to_captface" {
            let captureFaceController = segue.destination as! CaptureFaceController
            captureFaceController.forthData = forthData
            captureFaceController.threeData = threeData
            captureFaceController.from_code = from_code
            captureFaceController.empID = empID
        }
    }
    
    @IBAction func bCloseClicked(_ sender: UIButton) {
        if from_code == "REGISTER" {
            self.performSegue(withIdentifier: "segue_exit_to_register2", sender: nil)
        }
        else if from_code == "UPDATE" {
            self.performSegue(withIdentifier: "segue_exit_to_update", sender: nil)
        }
    }
    
    @IBAction func segue_exit_to_captprepare(_ segue: UIStoryboardSegue) {
    }
}

