//
//  DataFactory.swift
//  TIME
//
//  Created by Sruit Angkavanitsuk on 2/7/20.
//  Copyright © 2020 NSTDA. All rights reserved.
//

import CoreLocation
import UIKit

struct DataFactory {
    
    // 0 = normal
    // 1 = see log
    static let  DEBUG = true
    static let  DEBUG_SKIP_CHECK_WIFI = false
    
    // 1 = สวทช
    static let  BUSINESS_CODE = 1
    //static let SERVER_API_URL =  "http://203.185.99.253:8080/" // test server
    //static let SERVER_API_URL =  "http://10.228.8.19:8080/" // internal nectec test server
    static let SERVER_API_URL =  "http://app.attime.secteam.in.th:8080/" // internal nectec test server
    
    // 2 = กสทช
    /*
    static let  BUSINESS_CODE = 2
    static let SERVER_API_URL = "https://aheadapi.adecco.co.th/"
    */
    
    //Default Allow(1)/Not Allow(0) from step 3(1.5 api doc)
    static var IS_CHECKIN_ALLOW:Int = 0
    //Default isFirstTime = true when use APP Firsttime
    static var IS_LOADING_FIRSTTIME:Bool = true
    //Default BSSID use in step 3(6.4 api doc)
    static var CURRENT_BSSID:String = ""
    
    static let  APP_KEY = "DK0-9u3jfmcas-=dv-089780piockm32)(*S6281uhijksLCONISa98s765SGX" // use for enc/dec data
    //static var  EMP_ID = "" // will get when click CHECKIN, UPDATE, DELETE
    
    // ------------
    // use in loading
    // loading
    // step 1: check server available
    static let REQUEST_API_SERVER_STATUS_URL = SERVER_API_URL + "user/CheckServerAlive"
    // step 2: submit ip
    static let SUBMIT_API_LOG_IP_URL = SERVER_API_URL + "user/KeepIP"
    // step 3: submit wifi bssid
    static let REQUEST_API_CHECK_INDOOR_WIFI_URL = SERVER_API_URL + "user/HttpUtilsCheckIndoorWifi"
    
    static let SUBMIT_API_SIGNIN_ACCOUNT_URL = SERVER_API_URL + "user/LoginEveryTime"
    static let REQUEST_API_CHECK_MACADDRESS_URL = SERVER_API_URL + "user/CheckMac"
    
    // ------------
    // use in register account
    // step 1: use in register 1 page
    static let REQUEST_API_CHECK_ACCOUNT_ENROLL_URL = SERVER_API_URL + "user/DetectAlreadyAccountEnroll"
    // step 2: use in register 2 page
    static let SUBMIT_API_ACCOUNT_REGISTER_ENROLL_LDAP_URL = SERVER_API_URL + "user/Enroll_LDAP"
    // step 3: use to upload image in capture face page
    static let SUBMIT_API_ACCOUNT_REGISTER_UPLOAD_IMAGE_URL = SERVER_API_URL + "user/Enroll"
    // step 4: use to confirm in capture face page
    static let SUBMIT_API_ACCOUNT_REGISTER_MODEL_URL = SERVER_API_URL + "user/EnrollModel"
    // case: Cancel before confirm in capture face page
    static let SUBMIT_API_ACCOUNT_REGISTER_CANCEL_URL = SERVER_API_URL + "user/EnrollSixFaceStatus"
    
    // ------------
    // use in update account
    // step 1: call when click update in checkin page
    static let REQUEST_API_ACCOUNT_UPDATE_GET_EMPID_URL = SERVER_API_URL + "user/LoginUpdate"
    // step 2: call when input password in update page
    static let SUBMIT_API_ACCOUNT_UPDATE_VERIFY_PASSWORD_URL = SERVER_API_URL + "user/LoginUpdatePushBtn"
    // step 3: use to upload image in capture face page
    static let SUBMIT_API_ACCOUNT_UPDATE_UPLOAD_IMAGE_URL = SERVER_API_URL + "user/Update"
    // step 4: use to confirm in capture face page
    static let SUBMIT_API_ACCOUNT_UPDATE_MODEL_URL = SERVER_API_URL + "user/UpdateModel"
    // case: Cancel before confirm in capture face page
    static let SUBMIT_API_ACCOUNT_UPDATE_CANCEL_URL = SERVER_API_URL + "user/UpdateSixFaceStatus"
    
    // ------------
    // use in delete account
    // step 1: call when click remove in checkin page
    static let REQUEST_API_ACCOUNT_DELETE_GET_EMPID_URL = SERVER_API_URL + "user/LoginDelete"
    // step 2: call when input password in remove page
    static let SUBMIT_API_ACCOUNT_DELETE_VERIFY_PASSWORD_URL = SERVER_API_URL + "user/LoginDeletePushBtn"
    // step 3: call when confirm in remove page
    static let SUBMIT_API_ACCOUNT_DELETE_CONFIRM_URL = SERVER_API_URL + "user/Delete"
    
    // ------------
    // use in checkin
    // step 1: call when click checkin in checkin page
    static let REQUEST_API_ACCOUNT_CHECKIN_GET_EMPID_URL = SERVER_API_URL + "user/TimeAtt"
    // step 2: call when send image in capture face page
    static let SUBMIT_API_ACCOUNT_CHECKIN_UPLOAD_IMAGE_URL = SERVER_API_URL + "user/TimeAttCompareFace"
    // step 3: call to get face check result in capture face page
    static let SUBMIT_API_ACCOUNT_CHECKIN_VERIFY_FACE_URL = SERVER_API_URL + "user/TimeAttCompareFaceTrue"
    // step 4: call to confirm checkin in capture face page
    static let SUBMIT_API_ACCOUNT_CHECKIN_CONFIRM_URL = SERVER_API_URL + "user/FaceVeriYesNo"
    
    // ------------
    // use in check Agreement
    // step 1 : use check agreement by account in areement page
    static let SUMBIT_API_CHECK_AGREEMENT_URL = SERVER_API_URL + "user/CheckAgreement"
    // step 2 : call to get description consent
    static let REQUEST_API_CONSENT_DETAIL_DATA = SERVER_API_URL + "user/getAgreement"
    //step 3 : call when click agreement in areement page
    static let SUMBIT_API_ACCOUNT_CONSENT_URL = SERVER_API_URL + "user/Consent"
    
    static let storyBoard : UIStoryboard = UIStoryboard(name: "Main", bundle:nil)
    
    static func generatePostData(_ objects: [GeneratePostObject], boundaryKey: String = "X") -> String {
        var text = ""
        for object in objects {
            text += "--\(boundaryKey)\nContent-Disposition: form-data; name=\"\(object.name)\"\n\n\(object.value)\n"
        }
        text += "--\(boundaryKey)--"
        
        return text
    }

    class GeneratePostObject {
        var name: String
        var value: String
        
        init( name: String, value: String) {
            self.name = name
            self.value = value
        }
    }
}
