//
//  GetDataNetwork.swift
//  TIME
//
//  Created by JIDAPA LOMTAKU on 17/7/2563 BE.
//  Copyright © 2563 NSTDA. All rights reserved.
//

import Foundation
import CommonCrypto
import SystemConfiguration.CaptiveNetwork
import UIKit
import CoreLocation

// get wifi bssid
public class SSID {
    class func fetchNetworkInfo() -> [NetworkInfo]? {
        if let interfaces: NSArray = CNCopySupportedInterfaces() {
            var networkInfos = [NetworkInfo]()
            for interface in interfaces {
                let interfaceName = interface as! String
                var networkInfo = NetworkInfo(interface: interfaceName,
                                              success: false,
                                              ssid: nil,
                                              bssid: nil)
                if let dict = CNCopyCurrentNetworkInfo(interfaceName as CFString) as Dictionary? {
                    networkInfo.success = true
                    networkInfo.ssid = dict[kCNNetworkInfoKeySSID] as? String
                    networkInfo.bssid = dict[kCNNetworkInfoKeyBSSID] as? String
                    //networkInfo.ssid = dict[kCNNetworkInfoKeySSID as String] as? String
                    //networkInfo.bssid = dict[kCNNetworkInfoKeyBSSID as String] as? String
                }
                networkInfos.append(networkInfo)
            }
            return networkInfos
        }
        return nil
    }
}

struct NetworkInfo {
    var interface: String
    var success: Bool = false
    var ssid: String?
    var bssid: String?
}

/*
// Return IP address of WiFi interface (en0) as a String, or `nil`
func getWiFiAddress() -> String? {
    var address : String?

    // Get list of all interfaces on the local machine:
    var ifaddr : UnsafeMutablePointer<ifaddrs>?
    guard getifaddrs(&ifaddr) == 0 else { return nil }
    guard let firstAddr = ifaddr else { return nil }

    // For each interface ...
    for ifptr in sequence(first: firstAddr, next: { $0.pointee.ifa_next }) {
        let interface = ifptr.pointee

        // Check for IPv4 or IPv6 interface:
        let addrFamily = interface.ifa_addr.pointee.sa_family
        if addrFamily == UInt8(AF_INET) || addrFamily == UInt8(AF_INET6) {

            // Check interface name:
            let name = String(cString: interface.ifa_name)
            if  name == "en0" {

                // Convert interface address to a human readable string:
                var hostname = [CChar](repeating: 0, count: Int(NI_MAXHOST))
                getnameinfo(interface.ifa_addr, socklen_t(interface.ifa_addr.pointee.sa_len),
                            &hostname, socklen_t(hostname.count),
                            nil, socklen_t(0), NI_NUMERICHOST)
                address = String(cString: hostname)
            }
        }
    }
    freeifaddrs(ifaddr)

    return address
}
*/

/*func getWIFIInformation() -> String {
    let informationArray:NSArray? = CNCopySupportedInterfaces()
    print (informationArray)
    if let information = informationArray {
        let dict:NSDictionary? = CNCopyCurrentNetworkInfo(information[0] as! CFString)
        
        if dict != nil {
            let sDict = (dict!.compactMap({(key, value) -> String in
                //return "\(value)"
                return "\(value)"
            }) as Array).joined(separator: ",")
            
            return sDict
        }
    }
    
    return ""
}*/
