//
//  StringAddition.swift
//  TIME
//
//  Created by Sruit Angkavanitsuk on 3/7/20.
//  Copyright © 2020 NSTDA. All rights reserved.
//
import Foundation
import CommonCrypto

extension String {

    var length: Int {
        return count
    }

    subscript (i: Int) -> String {
        return self[i ..< i + 1]
    }

    func substring(fromIndex: Int) -> String {
        return self[min(fromIndex, length) ..< length]
    }

    func substring(toIndex: Int) -> String {
        return self[0 ..< max(0, toIndex)]
    }

    subscript (r: Range<Int>) -> String {
        let range = Range(uncheckedBounds: (lower: max(0, min(length, r.lowerBound)),
                                            upper: min(length, max(0, r.upperBound))))
        let start = index(startIndex, offsetBy: range.lowerBound)
        let end = index(start, offsetBy: range.upperBound - range.lowerBound)
        return String(self[start ..< end])
    }
    
    // ----
    func UTF8toBase64() -> String {
        let data = self.data(using: .utf8)
        //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
        return data?.base64EncodedString(options: []) ?? ""
        //return data?.base64EncodedStringWithOptions([]) ?? ""
    }

    func Base64toUTF8() -> String {
        let data = Data.init(base64Encoded: self, options: []) ?? Data()
        //let data = NSData.init(base64EncodedString: self, options: []) ?? NSData()
        return String(data: data, encoding: .utf8) ?? ""
        //return String(data: data, encoding: NSUTF8StringEncoding) ?? ""
    }
    
}
