//
//  UIAddition.swift
//  TIME
//
//  Created by Sruit Angkavanitsuk on 19/7/20.
//  Copyright © 2020 NSTDA. All rights reserved.
//

import Foundation
import UIKit


struct Dialog {
    
    static func showError(_ view: UIViewController, title: String = DataString.TITLE_ERROR_ALERT, detail: String,
                          isCloseViewController: Bool = false,
                          isCloseApplication: Bool = false /* can used only in loading controller */
    ) {
        DispatchQueue.main.async(execute: { () -> Void in
            let alert = UIAlertController(title: title, message: detail, preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in
                if isCloseApplication {
                    exit(0)
                }
                else if isCloseViewController {
                    view.dismiss(animated: false, completion: nil)
                }
            }))
            view.present(alert, animated: true, completion: nil)
        })
    }
    
    static func showSuccess(_ view: UIViewController, title: String = DataString.TITLE_SUCCESS_ALERT, detail: String) {
        DispatchQueue.main.async(execute: { () -> Void in
            let alert = UIAlertController(title: title, message: detail, preferredStyle: UIAlertController.Style.alert)
            alert.addAction(UIAlertAction(title: DataString.button_ok, style: UIAlertAction.Style.default, handler:  { (alert: UIAlertAction!) in
                
            }))
            view.present(alert, animated: true, completion: nil)
        })
    }
    
}


@IBDesignable
class FormTextField: UITextField {

    @IBInspectable var borderColor: UIColor? {
        didSet {
            layer.borderColor = borderColor?.cgColor
        }
    }

    @IBInspectable var borderWidth: CGFloat = 0 {
        didSet {
            layer.borderWidth = borderWidth
        }
    }
}
